clear all;
close all;

addpath('algorithms')
addpath('helpers')

path = ['results/'];
savepath = ['results/'];
% idx_sample = [48,48,5,5,5,5,5];
% idx_frame = [0,21,1,45,120,137,153];
idx_sample = [48];
idx_frame = [21];

type = '_data.mat';
tpfp = cell(size(idx_frame,2),2);
counter = 1;
thres_scale = 1;
f1measure = zeros(7,size(idx_frame,2));

for i = idx_frame
    tpfprec = zeros(2,7);
    disp(['processing the ',num2str(i),'th sample']);
    roadID = sprintf('%03d_%04d',idx_sample(counter),i);
    roadPath = ['data/', roadID,type];
    load(roadPath);
    
    gt_threshold = thres_scale*gt_threshold;
    X = inliers;
    O = outliers;
    target = [ones(1,size(X,2)),zeros(1,size(O,2))];
    X_tilde = [X O];
    
    disp(['outlier ratio:',num2str(size(O,2)/(size(X,2)+size(O,2)))]);
%%  DPCP
    DPCPName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    DPCPPath = [path, 'DPCP/', DPCPName,type];
    load(DPCPPath);
    [inliers, outliers] = cut(X_tilde, B_PSGD, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(1,counter) = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('DPCP:');
    [tpfprec(1,1),tpfprec(2,1)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, 'DPCP/',roadID, type], 'inliers', 'outliers');
%%  REAPER
    REAPERCName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    REAPERPath = [path, 'REAPER/', REAPERCName,type];
    load(REAPERPath, 'B_REAPER');
    [inliers, outliers] = cut(X_tilde, B_REAPER, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(2,counter) = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('REAPER:');
    [tpfprec(1,2),tpfprec(2,2)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, 'REAPER/',roadID,type], 'inliers', 'outliers');
%%  L21-RPCA
    RPCAName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    RPCAPath = [path, 'RPCA/', RPCAName,type];
    load(RPCAPath, 'B_L21');
    [inliers, outliers] = cut(X_tilde, B_L21, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(3,counter) = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('RPCA:');
    [tpfprec(1,3),tpfprec(2,3)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, 'RPCA/',roadID,type], 'inliers', 'outliers');

%%  RANSAC
%     RANSACName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    [B_RANSAC,~,trialcount] = RANSAC_PCA(X_tilde, 3, gt_threshold, tDPCP);
    [inliers, outliers] = cut(X_tilde, B_RANSAC, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(5,counter) = 2*tpr*prec/(tpr+prec+eps);
    f1m = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('RANSAC:');
    [tpfprec(1,5),tpfprec(2,5)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, 'RANSAC/', roadID, type], 'inliers', 'outliers','B_RANSAC','f1m');
    
%%  RANSAC 10x
%     RANSACName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    [B_RANSAC,~,~] = RANSAC_PCA(X_tilde, 3, gt_threshold, 10*tDPCP);
    [inliers, outliers] = cut(X_tilde, B_RANSAC, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(6,counter) = 2*tpr*prec/(tpr+prec+eps);
    f1m = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('10xRANSAC:');
    [tpfprec(1,6),tpfprec(2,6)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, '10xRANSAC/', roadID, type], 'inliers', 'outliers','B_RANSAC','f1m');
    
%%  RANSAC 100x
%     RANSACName = sprintf('%03d_%04d normal',idx_sample(counter),i);
    [B_RANSAC,~,~] = RANSAC_PCA(X_tilde, 3, gt_threshold, 100*tDPCP);
    [inliers, outliers] = cut(X_tilde, B_RANSAC, gt_threshold);
    score = zeros(1,size(X,2)+size(O,2));
    score(inliers) = 1;
    %f1measure
    [tpr,~,prec] = calMetic(score,target);
    f1measure(7,counter) = 2*tpr*prec/(tpr+prec+eps);
    f1m = 2*tpr*prec/(tpr+prec+eps);
    %
    disp('100xRANSAC:');
    [tpfprec(1,7),tpfprec(2,7)] = RANSACtpr(score,target);
    inliers = X_tilde(:,inliers);
    outliers = X_tilde(:,outliers);
    save([savepath, '100xRANSAC/', roadID, type], 'inliers', 'outliers','B_RANSAC','f1m');
    tpfp{counter,1} = tpfprec;
    tpfp{counter,2} = sprintf('%03d_%04d',idx_sample(counter),i);
    counter = counter +1;
end
% tpfp_name = sprintf('tpfp%03d',idx_sample);
% save([savepath, tpfp_name,type], 'tpfp','f1measure');




Algos = {'DPCP/','REAPER/','RPCA/','RANSAC','10xRANSAC','100xRANSAC'};
Algonames = {'DPCP-PSGM','REAPER','L21-RPCA','RANSAC','10xRANSAC','100xRANSAC'};
numAlgos = 6;

counter = 1;for i = idx_frame
    roadID = sprintf('%03d_%04d',idx_sample(counter),i);
    roadPath = ['data/', roadID,type];
    load(roadPath);
    ImgID = sprintf('data/image_02/data/%010d.png',i);
    img = imread(ImgID);
    figure;
    imshow(Draw_image(img,inliers,outliers));
    text(20,40,'Ground Truth','FontSize',50);
    
    for j = 1:numAlgos
        Algo = Algos{j};
        roadID = sprintf('%03d_%04d',idx_sample(counter),i);
        roadPath = ['results/',Algo,'/', roadID,type];
        load(roadPath);
        ImgID = sprintf('data/image_02/data/%010d.png',i);
        img = imread(ImgID);
        figure;
        imshow(Draw_image(img,inliers,outliers));
        text(20,40,Algonames{j},'FontSize',50);
    end
    
    counter = counter +1;
end


function [Roadimage] = Draw_image(img,inliers,outliers)
    %% Camera matrixs
    velo2rect = [ 2.34773698e-04,1.04494074e-02,9.99945389e-01,0.00000000e+00;
                 -9.99944155e-01,1.05653536e-02,1.24365378e-04,0.00000000e+00;
                 -1.05634778e-02,-9.99889574e-01,1.04513030e-02,0.00000000e+00;
                 -2.79681694e-03,-7.51087914e-02,-2.72132796e-01,1.00000000e+00];

    rect2disp = [721.5377,0.,0.,0.;
                   0.,721.5377,0.,0.;
                 609.5593 172.854,0.,1.;
                   0.,0.,387.5744,0.];
    %% inliers
    inliers_img = inliers'*velo2rect*rect2disp;
    inliers_img = inliers_img';
    inliers_img = inliers_img./inliers_img(4,:);

    inliers_visiable_idx = find(inliers_img(1,:) <= 1242 &...
                                    inliers_img(1,:) >= 0 &...
                                    inliers_img(2,:) <= 375 &...
                                    inliers_img(2,:) >= 0&...
                                    inliers_img(3,:) <= 255&...
                                    inliers_img(3,:) >= 0);
    inliers_img = inliers_img(:,inliers_visiable_idx);

    inliers2d_img = round(inliers_img(1:2,:))+1;
    for i = 1:size(inliers2d_img,2)
        y = inliers2d_img(1,i);
        x = inliers2d_img(2,i);
        img(x,y,1) = 0;
        img(x,y,2) = 0;
        img(x,y,3) = 255;
    end
    %% outliers
    outliers_img = outliers'*velo2rect*rect2disp;
    outliers_img = outliers_img';
    outliers_img = outliers_img./outliers_img(4,:);

    outliers_visiable_idx = find(outliers_img(1,:) <= 1242 &...
                                    outliers_img(1,:) >= 0 &...
                                    outliers_img(2,:) <= 375 &...
                                    outliers_img(2,:) >= 0&...
                                    outliers_img(3,:) <= 255&...
                                    outliers_img(3,:) >= 0);
    outliers_img = outliers_img(:,outliers_visiable_idx);

    outliers2d_img = round(outliers_img(1:2,:))+1;
    for i = 1:size(outliers2d_img,2)
        y = outliers2d_img(1,i);
        x = outliers2d_img(2,i);
        img(x,y,1) = 255;
        img(x,y,2) = 0;
        img(x,y,3) = 0;
    end
    Roadimage = img;
end

function [idInliers, idOutliers] = cut(X_tilde, B, th)
    dists = abs(B'*normc(X_tilde));
    idInliers = find(dists <= th);
    idOutliers = find(dists > th);
end
